.686			
;.MMx			
.k3d			
.XMM
.model flat, stdcall
option casemap:none

include  c:\masm32\include\windows.inc
include c:\masm32\include\kernel32.inc
include c:\masm32\include\masm32.inc
include c:\masm32\macros\macros.asm
include c:\masm32\macros\timers.asm
includelib c:\masm32\lib\kernel32.lib
includelib c:\masm32\lib\masm32.lib

Main		proto
SzCpy10      proto :DWORD,:DWORD
SzCpy11      proto :DWORD,:DWORD
SzCpy18      proto :DWORD,:DWORD
SzCpy19      proto :DWORD,:DWORD

.data

	
align 16
String1     DB  "Sample String 01234 56789 ABCDEF AaBbCcDdEeFfGgHhIiJjKkLlMMNnOoP",\
                "pQqRrSsTtUuVvWwXxYyZz Now I Know My ABC's, Won't You Come Play ",0
                dd 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
                                   
align 16
String2     DB  128 dup(0)
                dd 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

LOOP_COUNT  EQU 10000000        ; 10M iterations per timing result

SzSzCpy10    DB  "SzCpy10 (Lingo -> MMX): ",0
SzSzCpy11    DB  "SzCpy11 (Lingo-> SSE): ",0
SzSzCpy18    DB  "SzCpy18 (Mark Larson ->SSE):",0
SzSzCpy19    DB  "SzCpy19 (Mark Larson ->MMX):",0


.code

Start:
  Invoke Main
  Invoke ExitProcess,0

Main Proc
    print chr$(" Timing routines by MichaelW from MASM32 forums, http://www.masmforum.com/",13,10)
    mov   eax, input(" Please terminate any high-priority tasks and press ENTER to begin.")
    
    print chr$(13,10,13,10," 128-byte string copy timing results:",13,10,13,10)

; -----------------------------------------------  
     print addr SzSzCpy10
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke SzCpy10, addr String2, addr String1
    counter_end
    print ustr$(eax)
    print chr$(" clocks",13,10)
    invoke Sleep,250
; -----------------------------------------------  
    print addr SzSzCpy19
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke SzCpy19, addr String2, addr String1
    counter_end
    print ustr$(eax)
    print chr$(" clocks",13,10)
    invoke Sleep,250
; -----------------------------------------------   
    print addr SzSzCpy11
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke SzCpy11, addr String2, addr String1
    counter_end
    print ustr$(eax)
    print chr$(" clocks",13,10)
    invoke Sleep,250

; -----------------------------------------------   
    print addr SzSzCpy18
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke SzCpy18, addr String2, addr String1
    counter_end
    print ustr$(eax)
    print chr$(" clocks",13,10)
    invoke Sleep,250
; -----------------------------------------------   


    mov   eax, input(13,10," Press ENTER to exit...")
    ret
Main EndP



OPTION PROLOGUE:NONE   ; It  is SzCpy10  MMX by Lingo
OPTION EPILOGUE:NONE
comment * MMX by Lingo*
align 16
@@:
	movq		MM1,	[ecx+eax]
    movq		[edx+eax-8], MM0
@@2:
    movq		MM0,	[ecx+eax]					
	pcmpeqb	MM1,	MM7
	packsswb	MM1,	MM1
	movd		ebx,		MM1
	test			bl,		bl
	lea			eax,		[eax+8]
	je				@B
@@:									
	movzx	    ebx, byte ptr [ecx+eax-8]		
	add			eax, 1
	test			bl, bl
	mov			[edx+eax-9], bl
	jnz			@B
	mov			ebx, [esp+2*4]						
	ret			2*4
align 16
SzCpy10   proc    SzDest:DWORD, SzSource:DWORD
				mov		ecx, [esp+2*4]		; ecx = source
				xor		eax, eax
				mov		edx, [esp+1*4]		;  edx= destination
 				pxor		MM7,MM7
				movq	MM1, [ecx]
				mov		[esp+2*4], ebx		;  save ebx register
				je			@@2
 SzCpy10 endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef



OPTION	PROLOGUE:NONE  ; It  is SzCpy11  XMM by Lingo
OPTION	EPILOGUE:NONE 
comment * XMM by Lingo*
align 16
@@:
		movdqa		[edx+eax],XMM0
		add				eax,16
@@XM:
		pcmpeqb		XMM1, [ecx+eax]
		movdqa		XMM0, [ecx+eax]
		pmovmskb	ebx, XMM1
		test				ebx, ebx
		je					@B
@@:									
		movzx			ebx, byte ptr [ecx+eax]		
		add				eax, 1
		test				bl, bl
		mov				[edx+eax-1], bl
		jnz				@B
		mov				ebx, [esp+2*4]			; restore ebx	117 clocks
		ret				2*4
align 16
SzCpy11	proc		SzDest:DWORD, SzSource:DWORD     ; XMM by Lingo
				mov		ecx, [esp+2*4]		; ecx = source
 				pxor		XMM1,XMM1
				xor		eax, eax
				mov		edx, [esp+1*4]		;  edx= destination
				mov		[esp+2*4], ebx		;  save ebx register
				je			@@XM
SzCpy11	endp
OPTION	PROLOGUE:PrologueDef 
OPTION	EPILOGUE:EpilogueDef



OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
coMMent * XMM by Mark Larson *
SzCpy18  proc lpsrc:DWORD,lpdest:DWORD
				mov edx,[esp+4]
				mov ecx,[esp+8]
	align 16
	CopyOwords:
				movdqa		XMM0,[ecx]
				pxor				XMM1,XMM1
				pcmpeqb		XMM1,XMM0
				pmovmskb	eax,XMM1
				test				ax,ax
				jnz				CopyStragglers
				movdqa		[edx],XMM0
				add				ecx,16
				add				edx,16
				jmp				CopyOwords
		CopyStragglers:
				mov				al,[ecx]
				mov				[edx],al
				add				ecx,1
				add				edx,1
				test				al,al
				jnz				CopyStragglers
				ret	 8
SzCpy18	endp
OPTION	PROLOGUE:PrologueDef 
OPTION	EPILOGUE:EpilogueDef  

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
coMMent * MMX by Mark Larson *
SzCpy19  proc lpsrc:DWORD,lpdest:DWORD

		mov		edx,[esp+4]		; destination
		mov		ecx,[esp+8]		; source

	align 16
	CopyQwords1:
			pxor				MM1,MM1				;MM1 = 00 00 00 00 00 00 00 00
			movq			MM0,[ecx]			;MM0 = next 8 bytes
			pcmpeqb		MM1,MM0				;compare bytes in MM0 and MM1 - if equal then byte in MM1 = FF
			pmovmskb	eax,MM1				;put msb of each byte in MM1 into the bit in al
			test				al,al						;if any bit = 1 then there was a zero byte
			jnz				CopyStragglers1
			movq			[edx],MM0				;copy the qword
			add				ecx,8						;next 8 bytes
			add				edx,8
			jmp				CopyQwords1
CopyStragglers1:
			mov	al,[ecx]					;copy the string (including zero byte)
			mov	[edx],al
			add	ecx,1					;next byte
			add	edx,1
			test	al,al						;carry on until zero
			jnz	CopyStragglers1
			ret	8
SzCpy19 endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef       

End Start
